# *****************************************************************************
#
# Copyright (c) 2021, the pyEX authors.
#
# This file is part of the pyEX library, distributed under the terms of
# the Apache License 2.0.  The full license can be found in the LICENSE file.
#

import pyEX as p


class TestPyEXAPI:
    def test_all(self):
        for item in (
            "Client",
            "CommoditiesPoints",
            "CryptoSSE",
            "DEFAULT_API_LIMIT",
            "DeepChannels",
            "DeepChannelsSSE",
            "EconomicPoints",
            "FXSSE",
            "PyEXStopSSE",
            "PyEXception",
            "RatesPoints",
            "StockSSE",
        ):
            assert hasattr(p, item)

        for apimethod in (
            "account",
            "accountingQualityAndRiskMatrixAuditAnalytics",
            "accountingQualityAndRiskMatrixAuditAnalyticsDF",
            "acos",
            "ad",
            "add",
            "adosc",
            "advancedStats",
            "advancedStatsDF",
            "adx",
            "adxr",
            "analystDaysWallStreetHorizon",
            "analystDaysWallStreetHorizonDF",
            "analystRecommendations",
            "analystRecommendationsDF",
            "apo",
            "aroon",
            "aroonosc",
            "asin",
            "atan",
            "atr",
            "auctionWS",
            "avgprice",
            "balanceSheet",
            "balanceSheetDF",
            "batch",
            "batchDF",
            "beta",
            "boardOfDirectorsMeetingWallStreetHorizon",
            "boardOfDirectorsMeetingWallStreetHorizonDF",
            "bollinger",
            "bonusIssue",
            "bonusIssueDF",
            "book",
            "bookDF",
            "bookWS",
            "bop",
            "brent",
            "bulkBatch",
            "bulkBatchDF",
            "bulkMinuteBars",
            "bulkMinuteBarsDF",
            "businessUpdatesWallStreetHorizon",
            "businessUpdatesWallStreetHorizonDF",
            "buybacksWallStreetHorizon",
            "buybacksWallStreetHorizonDF",
            "calendar",
            "calendarDF",
            "cam1ExtractAlpha",
            "cam1ExtractAlphaDF",
            "capitalMarketsDayWallStreetHorizon",
            "capitalMarketsDayWallStreetHorizonDF",
            "cashFlow",
            "cashFlowDF",
            "cci",
            "cdj",
            "cdl2crows",
            "cdl3blackcrows",
            "cdl3inside",
            "cdl3linestrike",
            "cdl3outside",
            "cdl3starsinsouth",
            "cdl3whitesoldiers",
            "cdlabandonedbaby",
            "cdladvanceblock",
            "cdlbelthold",
            "cdlbreakaway",
            "cdlclosingmarubozu",
            "cdlconcealbabyswallow",
            "cdlcounterattack",
            "cdldarkcloudcover",
            "cdldoji",
            "cdldojistar",
            "cdldragonflydoji",
            "cdlengulfing",
            "cdleveningdojistar",
            "cdleveningstar",
            "cdlgapsidesidewhite",
            "cdlgravestonedoji",
            "cdlhammer",
            "cdlhangingman",
            "cdlharami",
            "cdlharamicross",
            "cdlhighwave",
            "cdlhikkake",
            "cdlhikkakemod",
            "cdlhomingpigeon",
            "cdlidentical3crows",
            "cdlinneck",
            "cdlinvertedhammer",
            "cdlkicking",
            "cdlkickingbylength",
            "cdlladderbottom",
            "cdllongleggeddoji",
            "cdllongline",
            "cdlmarubozu",
            "cdlmatchinglow",
            "cdlmathold",
            "cdlmorningdojistar",
            "cdlmorningstar",
            "cdlonneck",
            "cdlpiercing",
            "cdlrickshawman",
            "cdlrisefall3methods",
            "cdlseparatinglines",
            "cdlshootingstar",
            "cdlshortline",
            "cdlspinningtop",
            "cdlstalledpattern",
            "cdlsticksandwich",
            "cdltakuri",
            "cdltasukigap",
            "cdlthrusting",
            "cdltristar",
            "cdlunique3river",
            "cdlxsidegap3methods",
            "cdnj",
            "ceil",
            "ceoCompensation",
            "ceoCompensationDF",
            "chart",
            "chartDF",
            "cmo",
            "collections",
            "collectionsDF",
            "company",
            "companyDF",
            "companyTravelWallStreetHorizon",
            "companyTravelWallStreetHorizonDF",
            "convertFX",
            "convertFXDF",
            "corporateActions",
            "corporateActionsDF",
            "correl",
            "cos",
            "cosh",
            "cpi",
            "create",
            "creditcard",
            "cryptoBook",
            "cryptoBookDF",
            "cryptoBookSSE",
            "cryptoBookSSEAsync",
            "cryptoEventsSSE",
            "cryptoEventsSSEAsync",
            "cryptoPrice",
            "cryptoPriceDF",
            "cryptoQuote",
            "cryptoQuoteDF",
            "cryptoQuotesSSE",
            "cryptoQuotesSSEAsync",
            "cryptoSymbols",
            "cryptoSymbolsDF",
            "cryptoSymbolsList",
            "daily",
            "dailyDF",
            "dailyReturns",
            "deepWS",
            "delayedQuote",
            "delayedQuoteDF",
            "delete",
            "dema",
            "diesel",
            "directorAndOfficerChangesAuditAnalytics",
            "directorAndOfficerChangesAuditAnalyticsDF",
            "directory",
            "directoryDF",
            "distribution",
            "distributionDF",
            "div",
            "dividends",
            "dividendsBasic",
            "dividendsBasicDF",
            "dividendsDF",
            "download",
            "downloadReportNewConstructs",
            "downloadStockResearchReportValuEngine",
            "dx",
            "earnings",
            "earningsDF",
            "earningsToday",
            "earningsTodayDF",
            "ema",
            "esgCFPBComplaintsExtractAlpha",
            "esgCFPBComplaintsExtractAlphaDF",
            "esgCPSCRecallsExtractAlpha",
            "esgCPSCRecallsExtractAlphaDF",
            "esgDOLVisaApplicationsExtractAlpha",
            "esgDOLVisaApplicationsExtractAlphaDF",
            "esgEPAEnforcementsExtractAlpha",
            "esgEPAEnforcementsExtractAlphaDF",
            "esgEPAMilestonesExtractAlpha",
            "esgEPAMilestonesExtractAlphaDF",
            "esgFECIndividualCampaingContributionsExtractAlpha",
            "esgFECIndividualCampaingContributionsExtractAlphaDF",
            "esgOSHAInspectionsExtractAlpha",
            "esgOSHAInspectionsExtractAlphaDF",
            "esgSenateLobbyingExtractAlpha",
            "esgSenateLobbyingExtractAlphaDF",
            "esgUSASpendingExtractAlpha",
            "esgUSASpendingExtractAlphaDF",
            "esgUSPTOPatentApplicationsExtractAlpha",
            "esgUSPTOPatentApplicationsExtractAlphaDF",
            "esgUSPTOPatentGrantsExtractAlpha",
            "esgUSPTOPatentGrantsExtractAlphaDF",
            "estimates",
            "estimatesDF",
            "exchanges",
            "exchangesDF",
            "exp",
            "fdaAdvisoryCommitteeMeetingsWallStreetHorizon",
            "fdaAdvisoryCommitteeMeetingsWallStreetHorizonDF",
            "fedfunds",
            "figi",
            "figiDF",
            "files",
            "filingDueDatesWallStreetHorizon",
            "filingDueDatesWallStreetHorizonDF",
            "financials",
            "financialsDF",
            "fiscalQuarterEndWallStreetHorizon",
            "fiscalQuarterEndWallStreetHorizonDF",
            "fiveDayMLReturnRankingBrain",
            "fiveDayMLReturnRankingBrainDF",
            "fiveYear",
            "floor",
            "forex1MinuteSSE",
            "forex1MinuteSSEAsync",
            "forex1SecondSSE",
            "forex1SecondSSEAsync",
            "forex5SecondSSE",
            "forex5SecondSSEAsync",
            "forumWallStreetHorizon",
            "forumWallStreetHorizonDF",
            "fraudfactors",
            "fundOwnership",
            "fundOwnershipDF",
            "fundamentals",
            "fundamentalsDF",
            "fx",
            "fxSSE",
            "fxSSEAsync",
            "fxSymbols",
            "fxSymbolsDF",
            "fxSymbolsList",
            "gasmid",
            "gasprm",
            "gasreg",
            "gdp",
            "generalConferenceWallStreetHorizon",
            "generalConferenceWallStreetHorizonDF",
            "heatoil",
            "historicalFX",
            "historicalFXDF",
            "holidays",
            "holidaysDF",
            "holidaysWallStreetHorizon",
            "holidaysWallStreetHorizonDF",
            "housing",
            "ht_dcperiod",
            "ht_dcphase",
            "ht_phasor",
            "ht_sine",
            "ht_trendline",
            "ht_trendmode",
            "iexAuction",
            "iexAuctionAsync",
            "iexAuctionDF",
            "iexAuctionSSE",
            "iexAuctionSSEAsync",
            "iexBook",
            "iexBookAsync",
            "iexBookDF",
            "iexBookSSE",
            "iexBookSSEAsync",
            "iexDeep",
            "iexDeepAsync",
            "iexDeepDF",
            "iexDeepSSE",
            "iexDeepSSEAsync",
            "iexHist",
            "iexHistAsync",
            "iexHistDF",
            "iexLast",
            "iexLastAsync",
            "iexLastDF",
            "iexLastSSE",
            "iexLastSSEAsync",
            "iexOfficialPrice",
            "iexOfficialPriceAsync",
            "iexOfficialPriceDF",
            "iexOfficialPriceSSE",
            "iexOfficialPriceSSEAsync",
            "iexOpHaltStatus",
            "iexOpHaltStatusAsync",
            "iexOpHaltStatusDF",
            "iexOpHaltStatusSSE",
            "iexOpHaltStatusSSEAsync",
            "iexSecurityEvent",
            "iexSecurityEventAsync",
            "iexSecurityEventDF",
            "iexSecurityEventSSE",
            "iexSecurityEventSSEAsync",
            "iexSsrStatus",
            "iexSsrStatusAsync",
            "iexSsrStatusDF",
            "iexSsrStatusSSE",
            "iexSsrStatusSSEAsync",
            "iexSymbols",
            "iexSymbolsDF",
            "iexSymbolsList",
            "iexSystemEvent",
            "iexSystemEventAsync",
            "iexSystemEventDF",
            "iexSystemEventSSE",
            "iexSystemEventSSEAsync",
            "iexTops",
            "iexTopsAsync",
            "iexTopsDF",
            "iexTopsSSE",
            "iexTopsSSEAsync",
            "iexTradeBreak",
            "iexTradeBreakAsync",
            "iexTradeBreakDF",
            "iexTradeBreaksSSE",
            "iexTradeBreaksSSEAsync",
            "iexTrades",
            "iexTradesAsync",
            "iexTradesDF",
            "iexTradesSSE",
            "iexTradesSSEAsync",
            "iexTradingStatus",
            "iexTradingStatusAsync",
            "iexTradingStatusDF",
            "iexTradingStatusSSE",
            "iexTradingStatusSSEAsync",
            "incomeStatement",
            "incomeStatementDF",
            "indexChangesWallStreetHorizon",
            "indexChangesWallStreetHorizonDF",
            "indpro",
            "initialClaims",
            "insiderRoster",
            "insiderRosterDF",
            "insiderSummary",
            "insiderSummaryDF",
            "insiderTransactions",
            "insiderTransactionsDF",
            "institutionalMoney",
            "institutionalOwnership",
            "institutionalOwnershipDF",
            "internationalExchanges",
            "internationalExchangesDF",
            "internationalSymbols",
            "internationalSymbolsDF",
            "internationalSymbolsList",
            "intraday",
            "intradayDF",
            "ipoToday",
            "ipoTodayDF",
            "ipoUpcoming",
            "ipoUpcomingDF",
            "iposWallStreetHorizon",
            "iposWallStreetHorizonDF",
            "isinLookup",
            "isinLookupDF",
            "jet",
            "kScoreChinaKavout",
            "kScoreChinaKavoutDF",
            "kScoreKavout",
            "kScoreKavoutDF",
            "kama",
            "keyStats",
            "keyStatsDF",
            "languageMetricsOnCompanyFilingsAllBrain",
            "languageMetricsOnCompanyFilingsAllBrainDF",
            "languageMetricsOnCompanyFilingsBrain",
            "languageMetricsOnCompanyFilingsBrainDF",
            "languageMetricsOnCompanyFilingsDifferenceAllBrain",
            "languageMetricsOnCompanyFilingsDifferenceAllBrainDF",
            "languageMetricsOnCompanyFilingsDifferenceBrain",
            "languageMetricsOnCompanyFilingsDifferenceBrainDF",
            "largestTrades",
            "largestTradesDF",
            "lastWS",
            "latestFX",
            "latestFXDF",
            "legalActionsWallStreetHorizon",
            "legalActionsWallStreetHorizonDF",
            "linearreg",
            "linearreg_angle",
            "linearreg_intercept",
            "linearreg_slope",
            "list",
            "listDF",
            "ln",
            "log10",
            "logo",
            "logoNotebook",
            "logoPNG",
            "lookup",
            "macd",
            "macdext",
            "mama",
            "marketInfo",
            "marketNews",
            "marketNewsDF",
            "marketOhlc",
            "marketOhlcDF",
            "marketPrevious",
            "marketPreviousDF",
            "marketShortInterest",
            "marketShortInterestDF",
            "marketVolume",
            "marketVolumeDF",
            "marketYesterday",
            "marketYesterdayDF",
            "markets",
            "marketsDF",
            "mavp",
            "max",
            "maxindex",
            "medprice",
            "mergersAndAcquisitionsWallStreetHorizon",
            "mergersAndAcquisitionsWallStreetHorizonDF",
            "messageBudget",
            "metadata",
            "metadataDF",
            "mfi",
            "midpice",
            "midpoint",
            "min",
            "minindex",
            "minmax",
            "minmaxindex",
            "minus_di",
            "minus_dm",
            "mom",
            "momentum",
            "mult",
            "mutualFundSymbols",
            "mutualFundSymbolsDF",
            "mutualFundSymbolsList",
            "natgas",
            "natr",
            "newconstructs",
            "news",
            "newsDF",
            "newsSSE",
            "newsSSEAsync",
            "nextDayExtDate",
            "nextDayExtDateDF",
            "nonTimelyFilingsFraudFactors",
            "nonTimelyFilingsFraudFactorsDF",
            "obv",
            "officialPriceWS",
            "ohlc",
            "ohlcDF",
            "oneMonth",
            "oneYear",
            "opHaltStatusWS",
            "optionExpirations",
            "options",
            "optionsDF",
            "optionsSymbols",
            "optionsSymbolsDF",
            "optionsSymbolsList",
            "otcSymbols",
            "otcSymbolsDF",
            "otcSymbolsList",
            "overrideSSEUrl",
            "overrideUrl",
            "pause",
            "payAsYouGo",
            "payroll",
            "pcu",
            "peerCorrelation",
            "peerCorrelationPlot",
            "peercorrelation",
            "peers",
            "peersDF",
            "plus_di",
            "plus_dm",
            "points",
            "pointsDF",
            "ppo",
            "precisionalpha",
            "premium",
            "previous",
            "previousDF",
            "price",
            "priceDF",
            "priceDynamicsPrecisionAlpha",
            "priceDynamicsPrecisionAlphaDF",
            "priceTarget",
            "priceTargetDF",
            "productEventsWallStreetHorizon",
            "productEventsWallStreetHorizonDF",
            "propane",
            "queryMetadata",
            "queryMetadataDF",
            "quote",
            "quoteDF",
            "recent",
            "recentDF",
            "recessionProb",
            "records",
            "recordsDF",
            "refDividends",
            "refDividendsDF",
            "relevant",
            "relevantDF",
            "reportNewConstructs",
            "researchAndDevelopmentDaysWallStreetHorizon",
            "researchAndDevelopmentDaysWallStreetHorizonDF",
            "resume",
            "retailMoney",
            "returnOfCapital",
            "returnOfCapitalDF",
            "returns",
            "rightToPurchase",
            "rightToPurchaseDF",
            "rightsIssue",
            "rightsIssueDF",
            "roc",
            "rocp",
            "rocr",
            "rocr100",
            "rsi",
            "ruleInfo",
            "ruleOutput",
            "rules",
            "sameStoreSalesWallStreetHorizon",
            "sameStoreSalesWallStreetHorizonDF",
            "sar",
            "sarext",
            "schema",
            "search",
            "searchDF",
            "secondaryOfferingsWallStreetHorizon",
            "secondaryOfferingsWallStreetHorizonDF",
            "sectorPerformance",
            "sectorPerformanceDF",
            "sectors",
            "sectorsDF",
            "securityEventWS",
            "securityReclassification",
            "securityReclassificationDF",
            "securitySwap",
            "securitySwapDF",
            "seminarsWallStreetHorizon",
            "seminarsWallStreetHorizonDF",
            "sentiment",
            "sentimentDF",
            "sentimentSSE",
            "sentimentSSEAsync",
            "setProxy",
            "sevenDaySentimentBrain",
            "sevenDaySentimentBrainDF",
            "shareholderMeetingsWallStreetHorizon",
            "shareholderMeetingsWallStreetHorizonDF",
            "shortInterest",
            "shortInterestDF",
            "similarityIndexFraudFactors",
            "similarityIndexFraudFactorsDF",
            "sin",
            "sinh",
            "sixMonth",
            "sma",
            "socialSentimentStockTwits",
            "socialSentimentStockTwitsDF",
            "spinoff",
            "spinoffDF",
            "splits",
            "splitsDF",
            "spread",
            "spreadDF",
            "sqrt",
            "ssrStatusWS",
            "statistic",
            "stats",
            "statsDF",
            "status",
            "statusDF",
            "stddev",
            "stoch",
            "stochf",
            "stochrsi",
            "stockResearchReportValuEngine",
            "stockSplits",
            "stockSplitsDF",
            "stocksUS1MinuteSSE",
            "stocksUS1MinuteSSEAsync",
            "stocksUS1SecondSSE",
            "stocksUS1SecondSSEAsync",
            "stocksUS5SecondSSE",
            "stocksUS5SecondSSEAsync",
            "stocksUSNoUTP1MinuteSSE",
            "stocksUSNoUTP1MinuteSSEAsync",
            "stocksUSNoUTP1SecondSSE",
            "stocksUSNoUTP1SecondSSEAsync",
            "stocksUSNoUTP5SecondSSE",
            "stocksUSNoUTP5SecondSSEAsync",
            "stocksUSNoUTPSSE",
            "stocksUSNoUTPSSEAsync",
            "stocksUSSSE",
            "stocksUSSSEAsync",
            "sub",
            "sum",
            "summary",
            "summaryDF",
            "summitMeetingsWallStreetHorizon",
            "summitMeetingsWallStreetHorizonDF",
            "symbols",
            "symbolsDF",
            "symbolsList",
            "systemEventWS",
            "t3",
            "tacticalModel1ExtractAlpha",
            "tacticalModel1ExtractAlphaDF",
            "tags",
            "tagsDF",
            "tan",
            "tanh",
            "technicals",
            "technicalsDF",
            "tema",
            "tenDayMLReturnRankingBrain",
            "tenDayMLReturnRankingBrainDF",
            "tenK",
            "tenQ",
            "tenYear",
            "thirtyDaySentimentBrain",
            "thirtyDaySentimentBrainDF",
            "thirtyYear",
            "threeDayMLReturnRankingBrain",
            "threeDayMLReturnRankingBrainDF",
            "threeMonth",
            "threshold",
            "thresholdDF",
            "timeSeries",
            "timeSeriesDF",
            "timeSeriesInventory",
            "timeSeriesInventoryDF",
            "timeseries",
            "topsWS",
            "tradeBreakWS",
            "tradeShowsWallStreetHorizon",
            "tradeShowsWallStreetHorizonDF",
            "tradesWS",
            "tradingStatusWS",
            "trange",
            "trima",
            "trix",
            "tsf",
            "twentyOneDayMLReturnRankingBrain",
            "twentyOneDayMLReturnRankingBrainDF",
            "twentyYear",
            "twoDayMLReturnRankingBrain",
            "twoDayMLReturnRankingBrainDF",
            "twoYear",
            "typprice",
            "ultosc",
            "unemployment",
            "upcomingDividends",
            "upcomingDividendsDF",
            "upcomingEarnings",
            "upcomingEarningsDF",
            "upcomingEvents",
            "upcomingEventsDF",
            "upcomingIPOs",
            "upcomingIPOsDF",
            "upcomingSplits",
            "upcomingSplitsDF",
            "us15",
            "us30",
            "us5",
            "usage",
            "usageDF",
            "valuengine",
            "var",
            "vehicles",
            "volatility",
            "volumeByVenue",
            "volumeByVenueDF",
            "wallstreethorizon",
            "wclprice",
            "willr",
            "witchingHoursWallStreetHorizon",
            "witchingHoursWallStreetHorizonDF",
            "wma",
            "workshopsWallStreetHorizon",
            "workshopsWallStreetHorizonDF",
            "wraps",
            "wti",
            "yesterday",
            "yesterdayDF",
        ):
            assert hasattr(p, apimethod)
